#
#    Copyright (c) 2009-2021 Tom Keffer <tkeffer@gmail.com>
#
#    See the file LICENSE.txt for your full rights.
#

"""User extensions module

This module is imported from the main executable, so anything put here will be
executed before anything else happens. This makes it a good place to put user
extensions.
"""

import locale
# This will use the locale specified by the environment variable 'LANG'
# Other options are possible. See:
# http://docs.python.org/2/library/locale.html#locale.setlocale
locale.setlocale(locale.LC_ALL, '')

#
#"group_percent"     : "percent",		'] = 'group_percent'
#"group_volt"        : "volt",		'] = 'group_volt'
#"group_time"        : "unix_epoch",	'] = 'group_time'
#"group_fraction"    : "ppm",		'] = 'group_fraction'
#"group_count"       : "count",		'] = 'group_count'
#"group_distance"    : "km",		'] = 'group_distance'
#"group_speed2"      : "km_per_hour2",	'] = 'group_speed2'
#"group_rain"        : "cm",              '] = 'group_rain'
#"group_rainrate"    : "cm_per_hour",     '] = 'group_rainrate'

import weewx.units
weewx.units.obs_group_dict['pb'] = 'group_data'

weewx.units.obs_group_dict['sunshine_hours'] = 'group_radiation'
weewx.units.obs_group_dict['sunshine_time'] = 'group_radiation'

weewx.units.obs_group_dict['sunshineDur'] = 'group_deltatime'
weewx.units.obs_group_dict['rainDur'] = 'group_deltatime'
weewx.units.obs_group_dict['hailDur'] = 'group_deltatime'

weewx.units.obs_group_dict['co2_24h'] = 'group_fraction'

# VantagePro
weewx.units.obs_group_dict['stormRain'] = 'group_rain'
weewx.units.obs_group_dict['stormRainlast'] = 'group_rain'
weewx.units.obs_group_dict['rain24'] = 'group_rain'
weewx.units.obs_group_dict['rain60'] = 'group_rain'
weewx.units.obs_group_dict['rain15'] = 'group_rain'
weewx.units.obs_group_dict['hourRain'] = 'group_rain'
weewx.units.obs_group_dict['totalRain'] = 'group_rain'
weewx.units.obs_group_dict['monthET'] = 'group_rain'
weewx.units.obs_group_dict['yearET'] = 'group_rain'
weewx.units.obs_group_dict['stormStart'] = 'group_time'
weewx.units.obs_group_dict['windSpeed2'] = 'group_speed2'

weewx.units.obs_group_dict['signal1'] = 'group_percent'
weewx.units.obs_group_dict['signal2'] = 'group_percent'
weewx.units.obs_group_dict['signal3'] = 'group_percent'
weewx.units.obs_group_dict['signal4'] = 'group_percent'
weewx.units.obs_group_dict['signal5'] = 'group_percent'
weewx.units.obs_group_dict['signal6'] = 'group_percent'
weewx.units.obs_group_dict['signal7'] = 'group_percent'
weewx.units.obs_group_dict['signal8'] = 'group_percent'
weewx.units.obs_group_dict['signal1_2'] = 'group_percent'
weewx.units.obs_group_dict['signala'] = 'group_percent'
weewx.units.obs_group_dict['signalw'] = 'group_percent'
weewx.units.obs_group_dict['signalr'] = 'group_percent'



